/* iNomads.js -- Javascript for iNomads
 * 
 * (C) copyright 2007, Business Basic Systems Corporation
 * All rights reserved
 */

var chg_id = '';
var sig_id = '';
var fcs_id = '';

var oFcs;
var sFcsRule = '';

var cur_kc = 0;
var sFmt = '';
var bIgnoreFcs = 0;
var nNumber = 0;

var sPending = '';
var sPendLast = '';

/* Generic focus handling and signalling logic */

function iNmd_focus(ctl_id, sigOnExit, sigOnFcs, oCur, sRule)
{ if (bIgnoreFcs) 
  { bIgnoreFcs = 0;
    return;
  }

  if (ctl_id != fcs_id)
  { if ((sFcsRule != '') && (oFcs) && (oFcs != oCur))
    { if (!iNmd_Valid()) 
      { bIgnoreFcs = 1;
        alert('"' + oFcs.value + '"' + sInvalid + sFcsRule);
        
        bIgnoreFcs = 1;
        oFcs.focus();
        
        return;
      }
    }
  }

  document.inomads._fcs_id.value = ctl_id;

  if (ctl_id != fcs_id)
  { if (chg_id != '') 
    { if (sigOnFcs) 
		iNmd_Queue(chg_id);
	  else
	  { iNmd_Submit(chg_id);
	    return;
	  }
	}
	
    if (sigOnFcs) iNmd_Queue('F' + ctl_id); 

    chg_id = '';
  }

  fcs_id = ctl_id;

  oFcs = oCur;
  sFcsRule = sRule;

  sig_id = '';
  
  if (sigOnExit)
  { sig_id = ctl_id;

    if (sigOnExit == 2)
    { chg_id = ctl_id; // Force signal on exit regardless of change
    }
  }
 document.inomads._chg_id.value = chg_id; // Debug
 document.inomads._eom.value = '';
}

function iNmd_Pend()
{ submitform(sPending);
  sPendLast = '';
  sPending = '';
}

function iNmd_Submit(msg_id)
{ if (sPending == '') 
  { submitform(msg_id);
  }
  else
  { iNmd_Queue(msg_id);
  }
}

function iNmd_Queue(msg_id)
{ if (sPendLast == msg_id) return;
  sPendLast = msg_id;

  if (sPending == '')
   { sPending = msg_id;
     setTimeout(iNmd_Pend, 350);
   }
   else
   { sPending += ';' + msg_id;
   }
}

/* Needed for Pocket PC */

function iNmd_getElementById(find_id)
{ if (document.getElementById)
	return document.getElementById(find_id);
  
  var oForm = document.inomads;

  /* Manual hunt */
  
  for (var i = 0; i < oForm.length ; i++)
  { if ( oForm.elements[i].id == find_id) 
    { return oForm.elements[i];
    }
  }
  
  return null;
}

function iNmd_init(ctl_id, start_id)
{	var oStamp;
	
	oStamp = iNmd_getElementById('iNmdScript');
	if (oStamp) oStamp.innerHTML = 'inomads.js Rev: Dec 6, 2007.3';

	if (document.clipboardData)
		iNmd_is_ie = 1;
	else
		iNmd_is_ie = 0;

	if (iNmd_is_ie)
	{	iNmd_Posit();
		window.onresize = iNmd_Posit;
	}

	fcs_id = ctl_id;
	document.inomads._fcs_id.value = ctl_id;

	if (start_id != '')
	{	var oFld = iNmd_getElementById(start_id);
		if (oFld)
		{	oFld.focus();

			if (oFld.type == 'text') 
			{	if (document.selection)
				{	var oRng = document.selection.createRange();
					if (oRng)
					{	oRng.moveStart("character", -100000);
						oRng.moveEnd("character", 100000);
						oRng.select();
					}
				}
				else
				if ('selectionStart' in oFld)
				{	oFld.selectionStart = 0;
					oFld.selectionEnd = oFld.value.length;
				}
			}
		}
		else
		{	alert('Cannot find:' + start_id);
		}
	}
}

function iNmd_Posit()
{	var oElm;
	var oHdr;
	var oDiv;
	var tblHdr;
	var n;

	tblHdr = document.getElementsByTagName('thead');

	for (n=0; n < tblHdr.length; n++)
	{	oHdr = tblHdr[n];

		if (oHdr.id.substr(0,4) == '_lh_')
		{	if (oHdr.children)
				oElm = oHdr.children[0];
			else
			{	oElm = oHdr.firstChild;
				while (oElm)
				{	if (oElm.nodeName == 'TR') break;
					oElm = oElm.nextSibling;
				}
			}
			
			oDiv = document.getElementById('_dv_' + oHdr.id.substr(4));
			if (!oElm.iNmdDiv)
			{	var nHi;
				oElm.iNmdDiv = oDiv;
				
				oElm.iNmdTop = iNmd_Top(oElm) - iNmd_Top(oDiv);
				oElm.iNmdLeft = iNmd_Left(oElm) - iNmd_Left(oDiv);

				nHi = parseInt(oDiv.style.height);
				
				oDiv.style.paddingTop = oElm.offsetHeight + 'px';
				oDiv.style.height = (nHi - oElm.offsetHeight) + 'px';

				oElm.style.position = 'absolute';
				
			}
					
			oElm.style.top = iNmd_Top(oDiv) + oElm.iNmdTop + 'px';
			oElm.style.left = iNmd_Left(oDiv) + oElm.iNmdLeft + 'px';
		}
	}
}

/* iNmd_ChkChr(InputChar, FormatChar)
 * Returns: 0 = Reject, 1=Accept, 2=This is a formating char
 */

function iNmd_ChkChr(cInp, cFmt)
{ if (cFmt == 'x') return 1;
  if (cFmt == cInp) return 1;

  if (cFmt == '0')
  { if ((cInp >= '0') && (cInp <= '9')) return 1;
    return 0;
  }
  if (cFmt == 'a')
  { if ((cInp >= 'a') && (cInp <= 'z')) return 1;
    return 0;
  }
  if (cFmt == 'z')
  { if ((cInp >= 'a') && (cInp <= 'z')) return 1;
    if ((cInp >= '0') && (cInp <= '9')) return 1;
    return 0;
  }
  if (cFmt == '#')
  { if ((cInp >= '0') && (cInp <= '9')) return 1;
    if (cInp == ' ') return 1;
    return 0;
  }

  return 2;
}  

function iNmd_fmtchr(e, cNew)
{ var nStrt;
  var nLeng;
  var nOfst;

  var oRng;

  var oFld; 
  var sFld;

  var nOfsHash;
  var nOfsZero;

  var cNewOrig = cNew;

  if ((cNew < 32) && (cNew != 8)) return true;
      
  if (e.target) oFld = e.target; else oFld = e.srcElement;
  if (oFld.nodetype == 3) oFld = oFld.parentNode;

  sFld = oFld.value;

  if (sFld.length > sFmt.length) // Force correction
  { oFld.value = sFld.substr(0,sFmt.length);
    return false;
  }

  if (document.selection)
  { oRng = document.selection.createRange();
    
    nLeng = oRng.text.length;
    
    nOfst = oRng.moveEnd("character", sFld.length);
    nStrt = sFld.length - oRng.text.length;

    if (nOfst != 0) oRng.moveEnd("character", 0 - nOfst);

  }
  else
  { nStrt = oFld.selectionStart;
    nLeng = oFld.selectionEnd - nStrt;
  }

// If bksp if multiple columns treat as delete else move back one position

  nOfst = nStrt + nLeng;
  
  if (cNew == 8)
  { if (nLeng == 0)
    { if (nStrt == 0) return false;
      nStrt--;
    }
  }

  nOfsHash = sFmt.indexOf('#');
  nOfsZero = sFmt.indexOf('0');
  if (nOfsZero == -1) nOfsZero = sFmt.length + 1;

  if (nOfsHash != -1)
  { if (nOfsHash < nOfsZero)
    { return iNmd_numchr(cNew, sFmt, oFld, oRng, nStrt, nLeng);
    }
    
    /* We have a # after a zero */

    if (nOfst == sFld.length)
    { if ((nLeng == 0) || (nStrt == 0)) 
		return iNmd_digapnd(cNew, sFmt, oFld, oRng);
    }
  }

  if (nLeng == 0) nLeng = 1;

  var sRepl = '';
  var nRepl = 0;
  var chRepl = '';
  var bSts = 0;
  var nChrAdj = 1;

  for (nOfst = 0; nOfst < nLeng; nOfst++)
  { var chFmt = sFmt.charAt(nOfst + nStrt);

    if ((cNew == 127) || (cNew == 8))
    { if ((chFmt == '0') || (chFmt == '#'))
        chRepl = '0';
      else
      if ('AaXxZz'.indexOf(chFmt) != -1)
        chRepl = ' ';
      else
        chRepl = chFmt;
    }
    else
    { chRepl = String.fromCharCode(cNew);
      
      if ('AXZ'.indexOf(chFmt) != -1) 
      { chFmt = chFmt.toLowerCase();
        chRepl = chRepl.toUpperCase();
      }

      bSts = iNmd_ChkChr(chRepl,chFmt);
      if (bSts == 0) return false; // Bad character
      if (bSts == 2)
      { chRepl = chFmt;
        nChrAdj++;       
        if (nLeng < sFmt.length)
	{ nLeng++;
        }
      }
      else
       cNew = 127; // Delete reset rest of selection
      nRepl++;

    }

    sRepl += chRepl;
  }

  sRepl = oFld.value.substring(0, nStrt) + sRepl + oFld.value.substring(nStrt + sRepl.length, oFld.value.length);

  if ((cNewOrig == 8) || (cNewOrig == 127)) nChrAdj = 0;

  if (oRng)
  { oRng.expand("textedit");
    oRng.text = sRepl;

    oRng.moveEnd("character", 0 - sRepl.length);
    oRng.moveStart("character", nStrt + nChrAdj);
    oRng.select();

  }
  else
  { oFld.value = sRepl;

    oFld.selectionStart = nStrt + nChrAdj;
    oFld.selectionEnd = nStrt + nChrAdj;

  }

  return false; 
}

function iNmd_numchr(cNew, sFmt, oFld, oRng, nStrt, nLeng)
{ var sNew;
  var nSign;
  var nValue;
  var nScale;
  var nOfst;
  var chNew;
  var chFmt;
  var nPos;
  var nReqScale;
  var nDigit;
  var bImpliedDP = false;
  
  if ((cNew == 8) || (cNew == 127)) 
  { sNew = '';
    if (nLeng == 0) 
    { if (oFld.value.charAt(nStrt) == chDecimal) nStrt--;
      nLeng = 1;
    }
  }
  else
  { sNew = String.fromCharCode(cNew);
    if ((sNew == chDecimal) && (oFld.value.charAt(nStrt + nLeng) == chDecimal)) nLeng++;
  }

  nReqScale = 0;

  nOfst = sFmt.indexOf('.');
  if (nOfst != -1)
  { for(;nOfst < sFmt.length;)
    { chFmt = sFmt.charAt(nOfst++);
      if ((chFmt == '0') || (chFmt == '#')) nReqScale++;
    }
  }

  if (sFmt.charAt(0) == '\t')
  { sFmt = sFmt.substr(1);
    if ((nStrt + nLeng) == oFld.value.length) bImpliedDP = true;
  }

  sNew = oFld.value.substring(0, nStrt) + sNew + oFld.value.substring(nStrt + nLeng, oFld.value.length);

  nScale = -1000;
  nSign = 0;
  nValue = 0;
  nPos = 0;

  for (nOfst = 0; nOfst < sNew.length;)
  { chNew = sNew.charAt(nOfst++);
    if (chNew == ' ') continue;
    if (chNew == chCurrency) continue;
    if (chNew == chThousand) continue;
    if (chNew == chDecimal)
    { if (nScale >= 0) return false;
      nScale = 0;
      if (nOfst <= nStrt)  nPos++;
      continue;
    }
    if ((chNew >= '0') && (chNew <= '9'))
    { nValue = nValue * 10 + parseInt(chNew);
      nScale++;
      if (nOfst <= nStrt)
      { if ((nPos != 0) || (chNew != '0')) nPos++;
      }
      continue;
    }

    if (chNew == '+')
    { nSign = 1;
      continue;
    }
    
    if (chNew == '-') 
    { nSign = -1;
	  continue;
	}
    return false;
  }

  if (((cNew >= 48) && (cNew <= 57)) || (cNew == 46)) nPos++;
  
  if (cNew == 43) nSign = 1;   // Plus sign forces positive
 
  if (nScale < 0) nScale = 0;
 
  if (!bImpliedDP)
  { while (nScale < nReqScale)
    { nValue *= 10;
      nScale++;
    }
    while (nScale > nReqScale)
    { nDigit = nValue % 10;
      nValue = (nValue - nDigit) / 10;
      nScale--;
    }
  }

  sNew = '';

  for (nOfst = sFmt.length; nOfst > 0;)
  { chFmt = sFmt.charAt(--nOfst);
    if (chFmt == '-')
    { if (nSign == -1)
      { sNew = '-' + sNew;
      }
      else  
      { sNew = ' ' + sNew;
      }
      continue;
    }

    if (chFmt == '+')
    { if (nSign == -1)
      { sNew = '-' + sNew;
      }
      else  
      { sNew = '+' + sNew;
      }
      continue;
    }

    if (chFmt == ',')
    { if (nValue != 0) sNew = chThousand + sNew;
      continue;
    }

    if (chFmt == '.')
    { sNew = chDecimal + sNew;
      continue;
    }

    if (chFmt == '0')
    { nDigit = nValue % 10;
      sNew = nDigit + sNew;
      nValue = (nValue - nDigit) / 10;
      continue;
    }

    if (chFmt == '#')
    { if (nValue != 0) 
      { nDigit = nValue % 10;
        sNew = nDigit + sNew;
        nValue = (nValue - nDigit ) / 10;
      } 
      continue;
    }
    sNew = chFmt + sNew;
  }

  if (nValue != 0) return false;

  if (bImpliedDP)
  { nStrt = sNew.length;
  }
  else
  if (nPos == 0)
  { nStrt = sNew.indexOf(chDecimal);
    if (nStrt == -1) nStrt = sNew.length;
  }
  else
  { for (nStrt = 0; nStrt < sNew.length;nStrt++)
    { chNew = sNew.charAt(nStrt);
      if ((chNew == '.') || ((chNew >= '0') && (chNew <= '9')))
      { if (nPos == 0) break;
        nPos--;
      }
    }
  }

  if (oRng)
  { oRng.expand("textedit");
    oRng.text = sNew;

    oRng.moveEnd("character", 0 - sNew.length);
    oRng.moveStart("character", nStrt);
    oRng.select();

  }
  else
  { oFld.value = sNew;
  
    oFld.selectionStart = nStrt;
    oFld.selectionEnd = nStrt;
  }

  return false; 
}
 
function iNmd_digapnd(cNew, sFmt, oFld, oRng)
{ var sStrip;
  var nOfst;
  var nOfsNew;
  var sFld = oFld.value;
  var sNew;
  var chFmt;
    
  sStrip = '';  
  for (nOfst = 0 ;nOfst < sFld.length; nOfst++)
  { chFmt = sFmt.charAt(nOfst);
    if ((chFmt == '0') || (chFmt == '#')) sStrip += sFld.charAt(nOfst);
  }
 
  if ((cNew == 8) || (cNew == 127))
  { sStrip = '0' + sStrip;
  }
  else
  { if ((cNew < 48) || (cNew > 57)) return false;
    sStrip = sStrip.substr(1) + String.fromCharCode(cNew);
  }

  sNew = '';

  nOfsNew = 0;

  for (nOfst = 0 ;nOfst < sFld.length; nOfst++)
  { chFmt = sFmt.charAt(nOfst);
    if ((chFmt == '0') || (chFmt == '#'))
      sNew += sStrip.charAt(nOfsNew++);
    else
      sNew += sFld.charAt(nOfst);
  }

  if (oRng)
  { oRng.expand("textedit");
    oRng.text = sNew;

    oRng.moveEnd("character", sNew.length);
    oRng.moveStart("character", sNew.length);
    oRng.select();
  }
  else
  { oFld.value = sNew;
  
    oFld.selectionStart = sNew.length;
    oFld.selectionEnd = sNew.length;
  }

  return false; 
}      
  
function iNmd_Valid()
{ var sRule;

  sRule = sFcsRule;
  if (sRule == '') return;

  var nValue;
  var bValue; 	// Input is numeric

  var sMin;
  var sMax;

  var nOfst;
  var sCur;

  bValue = iNmd_ToNum(oFcs.value, 1);
  nValue = nNumber;

  while (sRule != '')
  { nOfst = sRule.indexOf(',');
    if (nOfst == -1)
    { sCur = sRule;
      sRule = '';
    }
    else
    { sCur = sRule.substring(0, nOfst);
      sRule = sRule.substring(nOfst + 1, sRule.length);
    }
    
    nOfst = sCur.indexOf('-', 1);
    if (nOfst == -1)
    { sMin = sCur;
      sMax = sMin;
    }
    else
    { sMin = sCur.substring(0, nOfst);
      sMax = sCur.substr(nOfst+1);
    }
//alert('Check v=' + oFcs.value + ' (' + nValue + ') Max:' + sMax + ' Min:' + sMin);
    if (bValue == true)
    { if (iNmd_ToNum(sMin, 0))
      { if (nValue < nNumber) continue;
        if (iNmd_ToNum(sMax, 0))
        { if (nValue <= nNumber) return true;
          continue;
        }
      }
    }

    if (sMin > oFcs.value) continue;
    if (sMax >= oFcs.value) return true;
  }
  return false;
}

function iNmd_ToNum(sVal, bExternal)
{ var nOfst;
  var chVal;

  var chPoint;  
  var nSign = 0;
  var nScale = -1000;

  nNumber = 0;

  if (bExternal)
   chPoint = chDecimal;
  else
   chPoint = '.';

  for (nOfst = 0; nOfst < sVal.length;)
  { chVal = sVal.charAt(nOfst++);

    if (bExternal)
    { if (chVal == chCurrency) continue;
      if (chVal == chThousand) continue;
    }

    if (chVal == chPoint)
    { if (nScale >= 0) return false;
      nScale = 0;
      continue;
    }

    if ((chVal >= '0') && (chVal <= '9')) 
    { nNumber = (nNumber * 10) + parseInt(chVal,10);
      nScale++;
      continue;
    }

    if (nSign == 0)
    { if (chVal == '-') 
      { nSign = -1;
        continue;
      }

      if (chVal == '+')
      { nSign = 1;
        continue;
      }
    }
    return false;
  }
  
  while (nScale > 0)
  { nNumber /= 10;
    nScale--;
  }
  return true;
}
   

// Keydown events

function iNmd_kdn(e)
{ cur_kc = (window.Event) ? e.which : e.keyCode ;

  if (cur_kc == 9)
  { document.inomads._eom.value = '\t'; 
  } 
  else
  if (cur_kc == 13) 
  { document.inomads._eom.value = '\r'; 
    iNmd_Submit(fcs_id);
 
    if (window.event) e.returnValue = false;
    return false;
  }
   
  return true;
}

function iNmd_kdn_FMT(e, f)
{ sFmt = f;
  
  if (iNmd_kdn(e))
  { if (cur_kc == 46)
    { cur_kc = 127;
    }
    else
    if (cur_kc != 8) 
       return true;
    
    if (iNmd_fmtchr(e, cur_kc)) return true;
    if (window.event) e.returnValue = false;
  }
  return false;
}

// Keypress events

function iNmd_key(e)
{ cNew = (window.Event) ? e.which : e.keyCode ;

  if ((cNew == 8) || ((cNew >= 32) && (cNew <= 127)))
  { chg_id = sig_id;
    document.inomads._chg_id.value = sig_id;
  }

  return true;
}

function iNmd_key_FMT(e)
{ var cNew = (window.Event) ? e.which : e.keyCode ;

  if ((cNew == 8) || ((cNew >= 32) && (cNew <= 127)))
  { chg_id = sig_id;
    document.inomads._chg_id.value = sig_id;
  }

  if (cNew != 8)
   if (iNmd_fmtchr(e, cNew)) return true;

  if (window.event) e.returnValue = false;
  return false;
}  

function iNmd_Cbx(oCbx, sV1, sV2)
{ var oHide = iNmd_getElementById('_v_' + fcs_id);

  if (oHide.value == sV1)
  { oHide.value = sV2;
    oCbx.checked = true;
  }
  else
  { oHide.value = sV1;
    oCbx.checked = false;
  }

  if (sig_id != '') iNmd_Submit(sig_id);
  return;
}

function iNmd_CbxBtn(oBtn, sV1, sV2, sT1, sT2)
{ var oHide = iNmd_getElementById('_v_' + fcs_id);

  if (oHide.value == sV1)
  { oHide.value = sV2;
    oBtn.value = sT2;
  }
  else
  { oHide.value = sV1;
    oBtn.value = sT1;
  }

  if (sig_id != '') iNmd_Submit(sig_id);
  return;
}


function iNmd_3bx(oCbx, sV1, sV2, sV3)
{ var oHide = iNmd_getElementById('_v_' + fcs_id);

  if (oHide.value == sV1)
  { oHide.value = sV2;
    oCbx.checked = true;
  }
  else
  if (oHide.value == sV2)
  { oHide.value = sV3;
    oCbx.checked = true;
    oCbx.className = 'iCheck_box_3rd';
  }
  else
  { oHide.value = sV1;
    oCbx.checked = false;
    oCbx.className = 'iCheck_box';
  }

  if (sig_id != '') iNmd_Submit(sig_id);
  return;
}

function iNmd_3bxBtn(oBtn, sV1, sV2, sV3, sT1, sT2, sT3)
{ var oHide = iNmd_getElementById('_v_' + fcs_id);

  if (oHide.value == sV1)
  { oHide.value = sV2;
    oBtn.value = sT2;
  }
  else
  if (oHide.value == sV2)
  { oHide.value = sV3;
    oBtn.value = sT3;
  }
  else
  { oHide.value = sV1;
    oBtn.value = sT1;
  }

  if (sig_id != '') iNmd_Submit(sig_id);
  return;
}

function iNmd_Rbt(oBtn, sVal)
{ var oHide = iNmd_getElementById('_v_' + fcs_id);

  if (oHide.iNmd_cur) oHide.iNmd_cur.className = "iRadio_btn";

  oHide.value = sVal;
  oBtn.className = "iRadio_btn_down";
  oHide.iNmd_cur = oBtn;

  if (sig_id != '') iNmd_Submit(sig_id);
  return;
}

function iNmd_Dbx_chg(oDbx, bAuto)
{  chg_id = fcs_id;
   document.inomads._chg_id.value = fcs_id;
   bAuto = true;
   if (bAuto) iNmd_Queue(chg_id);
}

function iNmd_Vdbx_arrow(sel_id)
{ var oList = iNmd_getElementById('_lst_' + sel_id);

  if (oList)
  { if (oList.style.display != 'block')
    { var x, y;
      var oText = iNmd_getElementById(sel_id);

      x = parseInt(oText.offsetLeft);
      y = parseInt(oText.offsetTop) + parseInt(oText.offsetHeight);

      while (oText = oText.offsetParent)
      { x += parseInt(oText.offsetLeft);
        y += parseInt(oText.offsetTop);
      }

      oList.style.top = y + 'px';
      oList.style.left = x + 'px' ;

      oList.style.display = 'block';
      oList.focus();
    }
    else
     oList.style.display = 'none';
  }
  return false;
}

function iNmd_Vdbx_blur(oList)
{ oList.style.display = 'none';
}

function iNmd_Vdbx_chg(sel_id, ctl_id)
{ var oText = iNmd_getElementById(sel_id);
  var oList = iNmd_getElementById('_lst_' + sel_id);

  oText.value = oList.options[oList.selectedIndex].text;
  oText.focus();
  oList.style.display = 'none';
  if (ctl_id != '') iNmd_Submit(ctl_id);
}

function PropDump(objectname, object) {
/*
 document.write("<table border=1 bgcolor=wheat><tr>");
  document.write("<td style='font-size: 18pt; font-weight: bold' colspan=2 align=center>");
  document.write("Properties of the <code>"+objectname+"</code> object</td></tr>");

  for (prop in object) {
     document.writeln("<tr><th>"+prop+"</th><td>"+
     object[prop]+"</td></tr>");
  }

  document.writeln("</table><p>");
*/

var t = 'Object information for :' + objectname;
for (prop in object)
{ t += '\t' + prop + ': ' + object[prop] + ';';
}
alert (t);


}

var Lbx_ovr = null;
var Lbx_clk = null;
var Lbx_aid = 0;

function iNmd_lAchk()
{ if (fcs_id == Lbx_aid)
  { if ((oFcs.value != '') && (oFcs.iNmd_orig != oFcs.value))
    { iNmd_Queue(fcs_id);
      Lbx_aid = 0;
    }
    else
	 setTimeout(iNmd_lAchk, 200);
  }
}

function iNmd_lAuto(ctl_id, sigOnExit, sigOnFcs, oCur, sRule)
{ iNmd_focus(ctl_id, sigOnExit, sigOnFcs, oCur, sRule);

  Lbx_aid = fcs_id;
  iNmd_lAchk();
  
  return;
}
  

function iNmd_Lbx_out()
{ if (Lbx_ovr != null)
  { if (Lbx_ovr.className == 'iListRowOver') Lbx_ovr.className = 'iListRow';
    Lbx_ovr = null;
  }
  return;
}

function iNmd_Lbx_clk()
{ var bChg;

  if (Lbx_ovr == null) return;
  Lbx_clk = null;
  
  bChg = iNmd_Lbx_sel(Lbx_ovr);
  
  if (Lbx_clk == oFcs) bIgnoreFcs = 1;
  Lbx_clk.focus();
  if (bChg) chg_id = fcs_id;
}

function iNmd_Lbx_sel(oSel)
{ var oTbl;
  var oRow;
  var oFld;
  var bMulti;
  var nIdx;
  var sId;
  
  oTbl = oSel;
 
  while (oTbl.nodeName != 'TABLE')
  { if (oTbl.nodeName == 'TR') oRow = oTbl;
	oTbl = oTbl.parentNode;
  }
  
  if (oTbl.id.charAt(2) == 'm')
    bMulti = true;
  else
    bMulti = false;

  nIdx = 0;
  oFld = oRow;
  while (oFld)
  { nIdx++;
    oFld = oFld.previousSibling;
  }

  sId = oTbl.id.substr(4);
  oFld = iNmd_getElementById(sId);
  Lbx_clk = oFld;
  
  sId = '_sl_' + sId;
    
  if (bMulti)
  { var sIdx = nIdx + ',';
    
    if (oRow.id != sId) 
    { oFld.value += sIdx;
      oRow.id = sId;
    }
    else
    { var sVal = ',' + oFld.value;
      var nOfs = sVal.indexOf(',' + sIdx);
      
      if (nOfs != -1)
      { oFld.value = oFld.value.substr(0,nOfs) + oFld.value.substr(nOfs + sIdx.length);
      }
      oRow.id = '';
   }
  }
  else
  { if (oRow.id == sId) return 0;
    
    var oOld = iNmd_getElementById(sId);
    
    if (oOld)
    { oOld.className = 'iListRow';
      oOld.id = '';
    }

    oFld.value = nIdx;
    oRow.id = sId;
  }

  if (oRow.id == sId)
    oRow.className = 'iListRowSel';
  else
    oRow.className = 'iListRow';
    
  if (Lbx_ovr)
  { if (Lbx_ovr.className == 'iListRow') Lbx_ovr.className = 'iListRowOver';
  }
  return 1;

}

function iNmd_Lbx_ovr(pObj)
{ iNmd_Lbx_out();

  Lbx_ovr = pObj;
  pObj.onmouseout = iNmd_Lbx_out;
  pObj.onclick = iNmd_Lbx_clk;
  
  if (pObj.className == 'iListRow') pObj.className = 'iListRowOver';
  return;
}

function iNmd_Top(oElm)
{ var y;
  y = parseInt(oElm.offsetTop);

  while (oElm = oElm.offsetParent)
  { y += parseInt(oElm.offsetTop);
  }
  
  return y;
}

function iNmd_Left(oElm)
{ var x;

  x = parseInt(oElm.offsetLeft);

  while (oElm = oElm.offsetParent)
  { x += parseInt(oElm.offsetLeft);
  }
  
  return x;
}

/* HdrMseMve - Header resize logic */

var xStrt;
var wdStrt;
var oCapture;
var oTdBody;
var oTdHead;

function iNmd_HdrSize(oTd, e)
{	oCapture = oTd;
    oTdHead = oTd;
    
	while (oTdHead.className != 'iListTtl') 
	{ oTdHead = oTdHead.parentNode;
	}

	oCapture.onmouseup = iNmd_HdrSet;//	'alert("up");' ; //iNmd_HdrSet();';
	oCapture.onmousemove = iNmd_HdrAdj; // 'alert("move");'; // iNmd_HdrAdj(event);';

	oCapture.setCapture();
	
//	if (!e) var e = window.event;

	xStrt = event.clientX; //(e.pageX) ? e.pageX : event.x;
	
	wdStrt = parseInt(oTdHead.width);
	
	oTd = oTdHead;
	while (oTd.nodeName != 'TABLE') 
	{ oTd = oTd.parentNode;
	}
	 
	oTdBody = oTd.rows[1].cells[oTdHead.cellIndex];
//PropDump("Body", oTdBody);	 
	return;
}

function iNmd_HdrSet()
{ oCapture.onmousemove = null;
  oCapture.onmouseup = null;
  oCapture.releaseCapture();
  oCapture = null;
}

function iNmd_HdrAdj()
{	var xPos;
    vae xChg;
	var wd;
	var i;
	var oTd;
	
	if (!oCapture) return;
//	if (!e) var e = window.event;
	xPos = event.clientX; //(e.pageX) ? e.pageX : event.x;
	
	xChg = xPos - xStrt;
alert( " chg = " + xChg + ' xPos=' + xPos + ' Strt=' + xStrt);
	
	if (xChg == 0) return;

	xStrt = xPos;
	wd = wdStrt + xChg;
	
	if (wd <= 0) return;
	
	oTdHead.style.width = wd + 'px';
	oTdBody.style.width = wd + 'px';
/*	
	oTd = oTdHead;
	while (oTd = oTd.nextSibling)
	{ oTd.offsetX = oTd.style.width;
	}
*/	
}

